Index: palm/trunk/SOURCE/vertical_nesting_mod.f90
===================================================================
--- palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2711)
+++ palm/trunk/SOURCE/vertical_nesting_mod.f90	(revision 2712)
@@ -917,8 +982,8 @@
       
                DO j = bdims_rem(2,1)-1, bdims_rem(2,2)+1
-                   DO if = nxl, nxr
-                       DO kf = bottomz, topz
-      
-                           eps    = ( zuf(kf) - zuc(k) ) / dzc
+                   DO iif = nxl, nxr
+                       DO kkf = bottomz, topz
+      
+                           eps    = ( zuf(kkf) - zuc(k) ) / dzc
                            alpha  = ( ( dzf / dzc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -926,7 +991,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           vprs(kf,j,if) = eminus * vprf(k-1,j,if) &
-                               + edot  * vprf(k,j,if)   &
-                               + eplus  * vprf(k+1,j,if)
+                           vprs(kkf,j,iif) = eminus * vprf(k-1,j,iif) &
+                               + edot  * vprf(k,j,iif)   &
+                               + eplus  * vprf(k+1,j,iif)
       
                        END DO
@@ -937,5 +1002,5 @@
              
            DO j = bdims_rem(2,1)-1, bdims_rem(2,2)+1
-               DO if = nxl, nxr
+               DO iif = nxl, nxr
       
                    eps    = ( zuf(nzt+1) - zuc(nztop+1) ) / dzc
@@ -945,7 +1010,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                   vprs(nzt+1,j,if)  = eminus * vprf(nztop,j,if)   &
-                       + edot  * vprf(nztop+1,j,if) &
-                       + eplus  * vprf(nztop+2,j,if)
+                   vprs(nzt+1,j,iif)  = eminus * vprf(nztop,j,iif)   &
+                       + edot  * vprf(nztop+1,j,iif) &
+                       + eplus  * vprf(nztop+2,j,iif)
       
                END DO
@@ -955,5 +1020,5 @@
            !-- Interpolation in y-direction (linear)
       
-           DO kf = nzb+1, nzt+1
+           DO kkf = nzb+1, nzt+1
                DO j = bdims_rem(2,1), bdims_rem(2,2)
       
@@ -961,8 +1026,8 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
       
-                   DO if = nxl, nxr
-                       DO jf = bottomy, topy
-                           v (kf,jf,if) = vprs(kf,j,if) + ( jf * dyf - j * dyc ) &
-                               * ( vprs(kf,j+1,if) - vprs(kf,j,if) ) / dyc
+                   DO iif = nxl, nxr
+                       DO jjf = bottomy, topy
+                           v (kkf,jjf,iif) = vprs(kkf,j,iif) + ( jjf * dyf - j * dyc ) &
+                               * ( vprs(kkf,j+1,iif) - vprs(kkf,j,iif) ) / dyc
                        END DO
                    END DO
@@ -977,5 +1042,4 @@
            DEALLOCATE( vprf, vprs )
       
-#endif
        END SUBROUTINE interpolate_to_fine_v
       
@@ -983,5 +1047,4 @@
        SUBROUTINE interpolate_to_fine_s( tag )
       
-#if defined( __parallel )
       
            USE arrays_3d
@@ -993,16 +1056,27 @@
       
            IMPLICIT NONE
-      
-          
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ptprs, ptprf
-      
-           INTEGER(iwp) :: nzbottom, nztop
+
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprf
       
       
@@ -1026,7 +1100,7 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                       DO if = bottomx, topx
-      
-                           eps    = ( if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
+                       DO iif = bottomx, topx
+      
+                           eps    = ( iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
                            alpha  = ( ( dxf / dxc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1034,5 +1108,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           ptprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           ptprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -1052,8 +1126,8 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
       
-                   DO if = nxl, nxr
-                       DO jf = bottomy, topy
-      
-                           eps    = ( jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
+                   DO iif = nxl, nxr
+                       DO jjf = bottomy, topy
+      
+                           eps    = ( jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
                            alpha  = ( ( dyf / dyc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1061,7 +1135,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           ptprs(k,jf,if) = eminus * ptprf(k,j-1,if) &
-                               + edot  * ptprf(k,j,if)   &
-                               + eplus  * ptprf(k,j+1,if)
+                           ptprs(k,jjf,iif) = eminus * ptprf(k,j-1,iif) &
+                               + edot  * ptprf(k,j,iif)   &
+                               + eplus  * ptprf(k,j+1,iif)
       
                        END DO
@@ -1079,9 +1153,9 @@
                topz    = (dzc/dzf) * k
       
-               DO jf = nys, nyn
-                   DO if = nxl, nxr
-                       DO kf = bottomz, topz
+               DO jjf = nys, nyn
+                   DO iif = nxl, nxr
+                       DO kkf = bottomz, topz
                        
-                           eps    = ( zuf(kf) - zuc(k) ) / dzc
+                           eps    = ( zuf(kkf) - zuc(k) ) / dzc
                            alpha  = ( ( dzf / dzc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1089,7 +1163,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           interpol3d(kf,jf,if) = eminus * ptprs(k-1,jf,if) &
-                               + edot  * ptprs(k,jf,if)   &
-                               + eplus  * ptprs(k+1,jf,if)
+                           interpol3d(kkf,jjf,iif) = eminus * ptprs(k-1,jjf,iif) &
+                               + edot  * ptprs(k,jjf,iif)   &
+                               + eplus  * ptprs(k+1,jjf,iif)
       
                        END DO
@@ -1099,6 +1173,6 @@
            END DO
                
-           DO jf = nys, nyn
-               DO if = nxl, nxr
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
       
                    eps    = ( zuf(nzt+1) - zuc(nztop+1) ) / dzc
@@ -1108,7 +1182,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                   interpol3d(nzt+1,jf,if) = eminus * ptprs(nztop,jf,if)   &
-                       + edot  * ptprs(nztop+1,jf,if) &
-                       + eplus  * ptprs(nztop+2,jf,if)
+                   interpol3d(nzt+1,jjf,iif) = eminus * ptprs(nztop,jjf,iif)   &
+                       + edot  * ptprs(nztop+1,jjf,iif) &
+                       + eplus  * ptprs(nztop+2,jjf,iif)
       
                END DO
@@ -1118,5 +1192,4 @@
            DEALLOCATE( ptprf, ptprs ) 
       
-#endif
        END SUBROUTINE interpolate_to_fine_s
       
@@ -1124,5 +1197,4 @@
        SUBROUTINE interpolate_to_fine_kh( tag )
       
-#if defined( __parallel )
       
            USE arrays_3d
@@ -1134,24 +1206,43 @@
       
            IMPLICIT NONE
-      
-          
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  uprs, uprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  vprs, vprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  wprs, wprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ptprs, ptprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  eprs, eprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  kmprs, kmprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  khprs, khprf
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  shfpr, uswspr, vswspr
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  tspr, uspr, z0pr
-      
-           INTEGER(iwp) :: nzbottom, nztop
+
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: uprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: wprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: eprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: kmprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: khprs
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: tspr 
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: uprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: wprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: eprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: kmprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: khprf
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uswspr
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: vswspr
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uspr
       
       
@@ -1178,7 +1269,7 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                       DO if = bottomx, topx
-      
-                           eps    = ( if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
+                       DO iif = bottomx, topx
+      
+                           eps    = ( iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
                            alpha  = ( ( dxf / dxc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1186,5 +1277,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           ptprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           ptprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -1204,8 +1295,8 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
       
-                   DO if = nxl, nxr
-                       DO jf = bottomy, topy
-      
-                           eps    = ( jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
+                   DO iif = nxl, nxr
+                       DO jjf = bottomy, topy
+      
+                           eps    = ( jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
                            alpha  = ( ( dyf / dyc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1213,7 +1304,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           ptprs(k,jf,if) = eminus * ptprf(k,j-1,if) &
-                               + edot  * ptprf(k,j,if)   &
-                               + eplus  * ptprf(k,j+1,if)
+                           ptprs(k,jjf,iif) = eminus * ptprf(k,j-1,iif) &
+                               + edot  * ptprf(k,j,iif)   &
+                               + eplus  * ptprf(k,j+1,iif)
       
                        END DO
@@ -1231,9 +1322,9 @@
                topz    = (dzc/dzf) * k
       
-               DO jf = nys, nyn
-                   DO if = nxl, nxr
-                       DO kf = bottomz, topz
+               DO jjf = nys, nyn
+                   DO iif = nxl, nxr
+                       DO kkf = bottomz, topz
                        
-                           eps    = ( zuf(kf) - zuc(k) ) / dzc
+                           eps    = ( zuf(kkf) - zuc(k) ) / dzc
                            alpha  = ( ( dzf / dzc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1241,7 +1332,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           kh(kf,jf,if) = eminus * ptprs(k-1,jf,if) &
-                               + edot  * ptprs(k,jf,if)   &
-                               + eplus  * ptprs(k+1,jf,if)
+                           kh(kkf,jjf,iif) = eminus * ptprs(k-1,jjf,iif) &
+                               + edot  * ptprs(k,jjf,iif)   &
+                               + eplus  * ptprs(k+1,jjf,iif)
       
                        END DO
@@ -1251,6 +1342,6 @@
            END DO
                
-           DO jf = nys, nyn
-               DO if = nxl, nxr
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
       
                    eps    = ( zuf(nzt+1) - zuc(nztop+1) ) / dzc
@@ -1260,7 +1351,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                   kh(nzt+1,jf,if) = eminus * ptprs(nztop,jf,if)   &
-                       + edot  * ptprs(nztop+1,jf,if) &
-                       + eplus  * ptprs(nztop+2,jf,if)
+                   kh(nzt+1,jjf,iif) = eminus * ptprs(nztop,jjf,iif)   &
+                       + edot  * ptprs(nztop+1,jjf,iif) &
+                       + eplus  * ptprs(nztop+2,jjf,iif)
       
                END DO
@@ -1270,10 +1361,8 @@
            DEALLOCATE( ptprf, ptprs ) 
       
-#endif
        END SUBROUTINE interpolate_to_fine_kh
       
        SUBROUTINE interpolate_to_fine_km( tag )
       
-#if defined( __parallel )
       
            USE arrays_3d
@@ -1285,24 +1374,42 @@
       
            IMPLICIT NONE
-      
-          
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  uprs, uprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  vprs, vprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  wprs, wprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ptprs, ptprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  eprs, eprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  kmprs, kmprf
-           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  khprs, khprf
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  shfpr, uswspr, vswspr
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  tspr, uspr, z0pr
-      
-           INTEGER(iwp) :: nzbottom, nztop
+
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: uprs 
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprs 
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: wprs 
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: eprs 
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: kmprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: khprs
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: vprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: wprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: ptprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: eprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: kmprf
+           REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: khprf
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uswspr
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: vswspr
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: tspr 
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uspr
       
       
@@ -1329,7 +1436,7 @@
                        topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                       DO if = bottomx, topx
-      
-                           eps    = ( if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
+                       DO iif = bottomx, topx
+      
+                           eps    = ( iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
                            alpha  = ( ( dxf / dxc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1337,5 +1444,5 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           ptprf(k,j,if) = eminus * work3d(k,j,i-1) &
+                           ptprf(k,j,iif) = eminus * work3d(k,j,i-1) &
                                + edot  * work3d(k,j,i)   &
                                + eplus  * work3d(k,j,i+1)
@@ -1355,8 +1462,8 @@
                    topy    = (nyf+1)/(nyc+1) * (j+1) - 1
       
-                   DO if = nxl, nxr
-                       DO jf = bottomy, topy
-      
-                           eps    = ( jf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
+                   DO iif = nxl, nxr
+                       DO jjf = bottomy, topy
+      
+                           eps    = ( jjf * dyf + 0.5 * dyf - j * dyc - 0.5 * dyc ) / dyc
                            alpha  = ( ( dyf / dyc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1364,7 +1471,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                           ptprs(k,jf,if) = eminus * ptprf(k,j-1,if) &
-                               + edot  * ptprf(k,j,if)   &
-                               + eplus  * ptprf(k,j+1,if)
+                           ptprs(k,jjf,iif) = eminus * ptprf(k,j-1,iif) &
+                               + edot  * ptprf(k,j,iif)   &
+                               + eplus  * ptprf(k,j+1,iif)
       
                        END DO
@@ -1382,9 +1489,9 @@
                topz    = (dzc/dzf) * k
       
-               DO jf = nys, nyn
-                   DO if = nxl, nxr
-                       DO kf = bottomz, topz
+               DO jjf = nys, nyn
+                   DO iif = nxl, nxr
+                       DO kkf = bottomz, topz
                        
-                           eps    = ( zuf(kf) - zuc(k) ) / dzc
+                           eps    = ( zuf(kkf) - zuc(k) ) / dzc
                            alpha  = ( ( dzf / dzc )**2.0 - 1.0 ) / 24.0
                            eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1392,7 +1499,7 @@
                            eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
        
-                           km(kf,jf,if) = eminus * ptprs(k-1,jf,if) &
-                               + edot  * ptprs(k,jf,if)   &
-                               + eplus  * ptprs(k+1,jf,if)
+                           km(kkf,jjf,iif) = eminus * ptprs(k-1,jjf,iif) &
+                               + edot  * ptprs(k,jjf,iif)   &
+                               + eplus  * ptprs(k+1,jjf,iif)
       
                        END DO
@@ -1402,6 +1509,6 @@
            END DO
                
-           DO jf = nys, nyn
-               DO if = nxl, nxr
+           DO jjf = nys, nyn
+               DO iif = nxl, nxr
       
                    eps    = ( zuf(nzt+1) - zuc(nztop+1) ) / dzc
@@ -1411,7 +1518,7 @@
                    eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                   km(nzt+1,jf,if)  = eminus * ptprs(nztop,jf,if)   &
-                       + edot  * ptprs(nztop+1,jf,if) &
-                       + eplus  * ptprs(nztop+2,jf,if)
+                   km(nzt+1,jjf,iif)  = eminus * ptprs(nztop,jjf,iif)   &
+                       + edot  * ptprs(nztop+1,jjf,iif) &
+                       + eplus  * ptprs(nztop+2,jjf,iif)
       
                END DO
@@ -1421,5 +1528,4 @@
            DEALLOCATE( ptprf, ptprs ) 
       
-#endif
        END SUBROUTINE interpolate_to_fine_km
       
@@ -1429,5 +1535,4 @@
        SUBROUTINE interpolate_to_fine_flux( tag )
       
-#if defined( __parallel )
       
            USE arrays_3d
@@ -1439,25 +1544,34 @@
       
            IMPLICIT NONE
-      
-          
-           INTEGER(iwp), intent(in) ::  tag
-           INTEGER(iwp)                             ::  i, j, k
-           INTEGER(iwp)                             ::  if, jf, kf
-           INTEGER(iwp)                             ::  bottomx, topx
-           INTEGER(iwp)                             ::  bottomy, topy
-           INTEGER(iwp)                             ::  bottomz, topz
-           REAL(wp)                                ::  eps, alpha, eminus, edot, eplus
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  shfpr, uswspr, vswspr
-           REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  tspr, uspr, z0pr
-      
-      
-           INTEGER(iwp) :: nzbottom, nztop
-      
-           ALLOCATE( shfpr (bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
+
+           INTEGER(iwp), intent(in)           :: tag
+           INTEGER(iwp)                       :: i
+           INTEGER(iwp)                       :: j
+           INTEGER(iwp)                       :: k
+           INTEGER(iwp)                       :: iif
+           INTEGER(iwp)                       :: jjf
+           INTEGER(iwp)                       :: kkf
+           INTEGER(iwp)                       :: nzbottom
+           INTEGER(iwp)                       :: nztop
+           INTEGER(iwp)                       :: bottomx
+           INTEGER(iwp)                       :: bottomy
+           INTEGER(iwp)                       :: bottomz
+           INTEGER(iwp)                       :: topx
+           INTEGER(iwp)                       :: topy
+           INTEGER(iwp)                       :: topz
+           REAL(wp)                           :: eps
+           REAL(wp)                           :: alpha
+           REAL(wp)                           :: eminus
+           REAL(wp)                           :: edot
+           REAL(wp)                           :: eplus
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uswspr
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: vswspr
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: tspr 
+           REAL(wp), DIMENSION(:,:), ALLOCATABLE   :: uspr
+      
            ALLOCATE( uswspr(bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
            ALLOCATE( vswspr(bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
            ALLOCATE( tspr  (bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
            ALLOCATE( uspr  (bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
-           ALLOCATE( z0pr  (bdims_rem(2,1)-1:bdims_rem(2,2)+1,nxl:nxr) )
       
            !
@@ -1473,7 +1587,7 @@
                    topx    = (nxf+1)/(nxc+1) * (i+1) - 1
       
-                   DO if = bottomx, topx
-      
-                       eps    = ( if * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
+                   DO iif = bottomx, topx
+      
+                       eps    = ( iif * dxf + 0.5 * dxf - i * dxc - 0.5 * dxc ) / dxc
                        alpha  = ( ( dxf / dxc )**2.0 - 1.0 ) / 24.0
                        eminus = eps * ( eps - 1.0 ) / 2.0 + alpha
@@ -1481,27 +1595,19 @@
                        eplus  = eps * ( eps + 1.0 ) / 2.0 + alpha
       
-                       shfpr(j,if)  = eminus * work2dshf(j,i-1) &
-                           + edot  * work2dshf(j,i)   &
-                           + eplus  * work2dshf(j,i+1)
-      
-                       uswspr(j,if) = eminus * work2dusws(j,i-1) &
+                       uswspr(j,iif) = eminus * work2dusws(j,i-1) &
                            + edot  * work2dusws(j,i)   &
                            + eplus  * work2dusws(j,i+1)
       
-                       vswspr(j,if) = eminus * work2dvsws(j,i-1) &
+                       vswspr(j,iif) = eminus * work2dvsws(j,i-1) &
                            + edot  * work2dvsws(j,i)   &
                            + eplus  * work2dvsws(j,i+1)
       
-                       tspr(j,if)   = eminus * work2dts(j,i-1) &
+                       tspr(j,iif)   = eminus * work2dts(j,i-1) &
                            + edot  * work2dts(j,i)   &
                            + eplus  * work2dts(j,i+1)
       
-                       uspr(j,if)   = eminus * work2dus(j,i-1) &
+                       uspr(j,iif)   = eminus * work2dus(j,i-1) &
                            + edot  * work2dus(j,i)   &
                            + eplus  * work2dus(j,i+1)
-      
-                       z0pr(j,if)   = eminus * work2dz0(j,i-1) &
-                           + edot  * work2dz0(j,i)   &
-                           + eplus  * work2dz0(j,i+1)
       
                    END DO
